xmonad-contrib-0.15: Third party extensions for xmonad

Copyright | (c) Joe Thornber <joe.thornber@gmail.com>
License | BSD3-style (see LICENSE)
Maintainer | Joe Thornber <joe.thornber@gmail.com>
Stability | stable
Portability | portable
Safe Haskell | None
Language | Haskell98

XMonad.Layout.Spiral

Contents

- Usage

Description

A spiral tiling layout.

Synopsis

- spiral :: Rational -> SpiralWithDir a
- spiralWithDir :: Direction -> Rotation -> Rational -> SpiralWithDir a
- data Rotation
  - = CW
  - | CCW
- data Direction
  - = East
  - | South
  - | West
  - | North
- data SpiralWithDir a

# Usage

You can use this module with the following in your `~/.xmonad/xmonad.hs`:

    import XMonad.Layout.Spiral

Then edit your `layoutHook` by adding the Spiral layout:

    myLayout =  spiral (6/7) ||| etc..
    main = xmonad def { layoutHook = myLayout }

For more detailed instructions on editing the layoutHook see:

XMonad.Doc.Extending

spiral :: Rational -> SpiralWithDir a Source #

A spiral layout. The parameter controls the size ratio between successive windows in the spiral. Sensible values range from 0 up to the aspect ratio of your monitor (often 4/3).

By default, the spiral is counterclockwise, starting to the east. See also `spiralWithDir`.

spiralWithDir :: Direction -> Rotation -> Rational -> SpiralWithDir a Source #

Create a spiral layout, specifying the starting cardinal direction, the spiral direction (clockwise or counterclockwise), and the size ratio.

data Rotation Source #

Constructors

CW |
CCW |

Instances

Read Rotation Source # |
Instance details Defined in XMonad.Layout.Spiral Methods readsPrec :: Int -> ReadS Rotation Source # readList :: ReadS [Rotation] Source # readPrec :: ReadPrec Rotation Source # readListPrec :: ReadPrec [Rotation] Source #
Show Rotation Source # |
Instance details Defined in XMonad.Layout.Spiral Methods showsPrec :: Int -> Rotation -> ShowS Source # show :: Rotation -> String Source # showList :: [Rotation] -> ShowS Source #

data Direction Source #

Constructors

East |
South |
West |
North |

Instances

Enum Direction Source # |

Instance details

Defined in XMonad.Layout.Spiral

Methods

succ :: Direction -> Direction Source #

pred :: Direction -> Direction Source #

toEnum :: Int -> Direction Source #

fromEnum :: Direction -> Int Source #

enumFrom :: Direction -> [Direction] Source #

enumFromThen :: Direction -> Direction -> [Direction] Source #

enumFromTo :: Direction -> Direction -> [Direction] Source #

enumFromThenTo :: Direction -> Direction -> Direction -> [Direction] Source #

Eq Direction Source # |
Instance details Defined in XMonad.Layout.Spiral Methods (==) :: Direction -> Direction -> Bool Source # (/=) :: Direction -> Direction -> Bool Source #
Read Direction Source # |
Instance details Defined in XMonad.Layout.Spiral Methods readsPrec :: Int -> ReadS Direction Source # readList :: ReadS [Direction] Source # readPrec :: ReadPrec Direction Source # readListPrec :: ReadPrec [Direction] Source #
Show Direction Source # |
Instance details Defined in XMonad.Layout.Spiral Methods showsPrec :: Int -> Direction -> ShowS Source # show :: Direction -> String Source # showList :: [Direction] -> ShowS Source #

data SpiralWithDir a Source #

Instances

LayoutClass SpiralWithDir a Source # |

Instance details

Defined in XMonad.Layout.Spiral

Methods

runLayout :: Workspace WorkspaceId (SpiralWithDir a) a -> Rectangle -> X ([(a, Rectangle)], Maybe (SpiralWithDir a)) Source #

doLayout :: SpiralWithDir a -> Rectangle -> Stack a -> X ([(a, Rectangle)], Maybe (SpiralWithDir a)) Source #

pureLayout :: SpiralWithDir a -> Rectangle -> Stack a -> [(a, Rectangle)] Source #

emptyLayout :: SpiralWithDir a -> Rectangle -> X ([(a, Rectangle)], Maybe (SpiralWithDir a)) Source #

handleMessage :: SpiralWithDir a -> SomeMessage -> X (Maybe (SpiralWithDir a)) Source #

pureMessage :: SpiralWithDir a -> SomeMessage -> Maybe (SpiralWithDir a) Source #

description :: SpiralWithDir a -> String Source #

Read (SpiralWithDir a) Source # |
Instance details Defined in XMonad.Layout.Spiral Methods readsPrec :: Int -> ReadS (SpiralWithDir a) Source # readList :: ReadS [SpiralWithDir a] Source # readPrec :: ReadPrec (SpiralWithDir a) Source # readListPrec :: ReadPrec [SpiralWithDir a] Source #
Show (SpiralWithDir a) Source # |
Instance details Defined in XMonad.Layout.Spiral Methods showsPrec :: Int -> SpiralWithDir a -> ShowS Source # show :: SpiralWithDir a -> String Source # showList :: [SpiralWithDir a] -> ShowS Source #